"""autogenerated by genpy from ethercat_monitor/EtherCATSystemStatus.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ethercat_monitor.msg
import genpy

class EtherCATSystemStatus(genpy.Message):
  _md5sum = "fff60f18cfeaaa81990d0fcc676e1fe2"
  _type = "ethercat_monitor/EtherCATSystemStatus"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """time stamp
EtherCATMasterStatus   master
EtherCATDeviceStatus[] devices
================================================================================
MSG: ethercat_monitor/EtherCATMasterStatus
int64 sent
int64 dropped
int64 late
int64 unassigned_drops
================================================================================
MSG: ethercat_monitor/EtherCATDeviceStatus
# represents the data for a single EtherCAT device
string name
string hardware_id
int32  ring_position
int32  epu_errors
int32  pdi_errors
bool   valid 
EtherCATDevicePortStatus[] ports  # EtherCAT devices have 1-4 ports
================================================================================
MSG: ethercat_monitor/EtherCATDevicePortStatus
# Represents diagnostic information for a signle port of an EtherCAT device
int32 rx_errors
int32 forwarded_rx_errors
int32 frame_errors
int32 lost_links
bool open

# estimate of dropped packets that where cause by this port
# calculated by correlating occurence of frame_errors with drops from ethercat master data
int32 est_drops  


"""
  __slots__ = ['stamp','master','devices']
  _slot_types = ['time','ethercat_monitor/EtherCATMasterStatus','ethercat_monitor/EtherCATDeviceStatus[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       stamp,master,devices

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EtherCATSystemStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.master is None:
        self.master = ethercat_monitor.msg.EtherCATMasterStatus()
      if self.devices is None:
        self.devices = []
    else:
      self.stamp = genpy.Time()
      self.master = ethercat_monitor.msg.EtherCATMasterStatus()
      self.devices = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_2I4q.pack(_x.stamp.secs, _x.stamp.nsecs, _x.master.sent, _x.master.dropped, _x.master.late, _x.master.unassigned_drops))
      length = len(self.devices)
      buff.write(_struct_I.pack(length))
      for val1 in self.devices:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.hardware_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_3iB.pack(_x.ring_position, _x.epu_errors, _x.pdi_errors, _x.valid))
        length = len(val1.ports)
        buff.write(_struct_I.pack(length))
        for val2 in val1.ports:
          _x = val2
          buff.write(_struct_4iBi.pack(_x.rx_errors, _x.forwarded_rx_errors, _x.frame_errors, _x.lost_links, _x.open, _x.est_drops))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.master is None:
        self.master = ethercat_monitor.msg.EtherCATMasterStatus()
      if self.devices is None:
        self.devices = None
      end = 0
      _x = self
      start = end
      end += 40
      (_x.stamp.secs, _x.stamp.nsecs, _x.master.sent, _x.master.dropped, _x.master.late, _x.master.unassigned_drops,) = _struct_2I4q.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.devices = []
      for i in range(0, length):
        val1 = ethercat_monitor.msg.EtherCATDeviceStatus()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.hardware_id = str[start:end].decode('utf-8')
        else:
          val1.hardware_id = str[start:end]
        _x = val1
        start = end
        end += 13
        (_x.ring_position, _x.epu_errors, _x.pdi_errors, _x.valid,) = _struct_3iB.unpack(str[start:end])
        val1.valid = bool(val1.valid)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.ports = []
        for i in range(0, length):
          val2 = ethercat_monitor.msg.EtherCATDevicePortStatus()
          _x = val2
          start = end
          end += 21
          (_x.rx_errors, _x.forwarded_rx_errors, _x.frame_errors, _x.lost_links, _x.open, _x.est_drops,) = _struct_4iBi.unpack(str[start:end])
          val2.open = bool(val2.open)
          val1.ports.append(val2)
        self.devices.append(val1)
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_2I4q.pack(_x.stamp.secs, _x.stamp.nsecs, _x.master.sent, _x.master.dropped, _x.master.late, _x.master.unassigned_drops))
      length = len(self.devices)
      buff.write(_struct_I.pack(length))
      for val1 in self.devices:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.hardware_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_3iB.pack(_x.ring_position, _x.epu_errors, _x.pdi_errors, _x.valid))
        length = len(val1.ports)
        buff.write(_struct_I.pack(length))
        for val2 in val1.ports:
          _x = val2
          buff.write(_struct_4iBi.pack(_x.rx_errors, _x.forwarded_rx_errors, _x.frame_errors, _x.lost_links, _x.open, _x.est_drops))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.master is None:
        self.master = ethercat_monitor.msg.EtherCATMasterStatus()
      if self.devices is None:
        self.devices = None
      end = 0
      _x = self
      start = end
      end += 40
      (_x.stamp.secs, _x.stamp.nsecs, _x.master.sent, _x.master.dropped, _x.master.late, _x.master.unassigned_drops,) = _struct_2I4q.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.devices = []
      for i in range(0, length):
        val1 = ethercat_monitor.msg.EtherCATDeviceStatus()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.hardware_id = str[start:end].decode('utf-8')
        else:
          val1.hardware_id = str[start:end]
        _x = val1
        start = end
        end += 13
        (_x.ring_position, _x.epu_errors, _x.pdi_errors, _x.valid,) = _struct_3iB.unpack(str[start:end])
        val1.valid = bool(val1.valid)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.ports = []
        for i in range(0, length):
          val2 = ethercat_monitor.msg.EtherCATDevicePortStatus()
          _x = val2
          start = end
          end += 21
          (_x.rx_errors, _x.forwarded_rx_errors, _x.frame_errors, _x.lost_links, _x.open, _x.est_drops,) = _struct_4iBi.unpack(str[start:end])
          val2.open = bool(val2.open)
          val1.ports.append(val2)
        self.devices.append(val1)
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3iB = struct.Struct("<3iB")
_struct_4iBi = struct.Struct("<4iBi")
_struct_2I4q = struct.Struct("<2I4q")
